
# hash functions
################
def bigMess(serial,key,tableSize):
    prefix = 'w'*serial
    shifted = [chr((ord(key[i])+i%serial)%128) for i in range(len(key))]
    shifted = ''.join(shifted)
    hashmod = hash(prefix+shifted)%tableSize
    res = hashmod + hashmod%13*(tableSize//13)
    if (hashmod%17)%2:
        res = res+hashmod%4
    return res%tableSize

def h1(key,tableSize):
    return bigMess(3,key,tableSize)

def h2(key,tableSize):
    return bigMess(5,key,tableSize)

def h3(key,tableSize):
    return bigMess(7,key,tableSize)

def h4(key,tableSize):
    return bigMess(11,key,tableSize)

# Cuckoo class
##############
class Cuckoo:
    def __init__(self,funcs,tableSize,maxDepth):
        self.table = [""]*tableSize
        self.funcs = funcs
        self.excess = []
        self.maxDepth = maxDepth
        self.size = tableSize

    def __repr__(self):
        return "<Cuckoo Hash:{0}, excess:{1}>".format(self.table,self.excess)

    @staticmethod
    def emptySlot():
        return ""
    
    def find(self,key):
        pass

    def remove(self,key):
        pass

    def insert(self,key):
        pass
